var db = Titanium.Database.open("testdb");
db.execute('CREATE TABLE IF NOT EXISTS storedInfo(id INTEGER PRIMARY KEY AUTOINCREMENT, type TEXT, data TEXT);');

var topId;
doRows();

$.inventoryAddItem.addEventListener("click", function(e) {
	Ti.API.info("click test");
	Titanium.Media.showCamera({
		saveToPhotoGallery : true,
		mediaTypes : Titanium.Media.MEDIA_TYPE_PHOTO,
		success : function(image) {
			
			var fileExtension = image.media.mimeType.split('/')[1];

			Ti.API.info("fileExtension: " + fileExtension);

			var fileStem = Math.floor((Math.random() * 10000) + 1) + "." + fileExtension;

			var imageFile = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, fileStem);

			Ti.API.info("imageFile : " + imageFile);

			if (OS_BLACKBERRY) {
				if (!imageFile.exists()) {
					imageFile.createFile();
				}
			}

			var test = imageFile.write(image.media);
			
			Ti.API.info("test if file is written: " + test);
			 
			Ti.API.info(image.media);
			entry = {
				itemId : topId + 1,
				image : image.media,
				filename: fileStem,
				details : ""
			};
			addNewEntry(entry, "", "new");
			
		}
	});
});

function addNewEntry(entry, entryId, entryType) {
	var currentEntry = entry;
	if (entryId == "") {
		db.execute('INSERT INTO storedInfo (data, type) VALUES (\'' + JSON.stringify(currentEntry) + '\', "homeDocument")');
		entryId = db.lastInsertRowId;
	}
	var wrapperView = Ti.UI.createView({

	});
	var wrapperStyle = $.createStyle({
		classes : "homeInventoryItemWrapper"
	});
	wrapperView.applyProperties(wrapperStyle);

	//////////////////////////////////////
	var itemDetailsWrapper = Ti.UI.createView({

	});
	var itemDetailsWrapperStyle = $.createStyle({
		classes : "itemDetailsWrapper"
	});
	itemDetailsWrapper.applyProperties(itemDetailsWrapperStyle);

	var paddingView = Ti.UI.createView({

	});
	var paddingViewStyle = $.createStyle({
		classes : "bottomPadding"
	});
	paddingView.applyProperties(paddingViewStyle);

	var itemDetailsLabel = Ti.UI.createLabel({
		text : "Item Description",

	});
	var itemDetailsLabelStyle = $.createStyle({
		classes : "itemDetailsLabel"
	});
	itemDetailsLabel.applyProperties(itemDetailsLabelStyle);

	var itemDetailsTextarea = Ti.UI.createTextArea({
		value : currentEntry.details,
		softKeyboardOnFocus : OS_ANDROID ? Titanium.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS : ""
	});
	var itemDetailsTextareaStyle = $.createStyle({
		classes : "itemDetailsTextarea"
	});
	itemDetailsTextarea.applyProperties(itemDetailsTextareaStyle);

	var itemDetailsButtons = Ti.UI.createView({

	});
	var itemDetailsButtonsStyle = $.createStyle({
		classes : "itemDetailsButtons"
	});
	itemDetailsButtons.applyProperties(itemDetailsButtonsStyle);

	var homeInventoryShare = Ti.UI.createImageView({
		image : "/images/home/homeInventorySave.png"
	});
	var homeInventoryShareStyle = $.createStyle({
		classes : "homeInventoryShare"
	});
	homeInventoryShare.applyProperties(homeInventoryShareStyle);

	var homeInventoryDelete = Ti.UI.createImageView({
		image : "/images/home/homeInventoryTrash.png"
	});
	var homeInventoryDeleteStyle = $.createStyle({
		classes : "homeInventoryDelete"
	});
	homeInventoryDelete.applyProperties(homeInventoryDeleteStyle);

	////////////////
	var imageView = Ti.UI.createImageView({
		image : Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, entry.filename)
	});
	var imageStyle = $.createStyle({
		classes : "homeInventoryItemImage"
	});
	imageView.applyProperties(imageStyle);

	itemDetailsWrapper.add(itemDetailsTextarea);
	itemDetailsButtons.add(homeInventoryShare);
	itemDetailsButtons.add(homeInventoryDelete);
	itemDetailsWrapper.add(itemDetailsButtons);

	wrapperView.add(imageView);
	wrapperView.add(itemDetailsLabel);
	wrapperView.add(itemDetailsWrapper);
	wrapperView.add(paddingView);

	$.inventoryItems.add(wrapperView);

	homeInventoryShare.addEventListener("click", function(e) {
		currentEntry.details = itemDetailsTextarea.value;
		db.execute('UPDATE storedInfo SET data = \'' + JSON.stringify(currentEntry) + '\' WHERE id = ' + entryId);
		alert("Saved");
	});
	homeInventoryDelete.addEventListener("click", function(e) {
		var dialog = Ti.UI.createAlertDialog({
			cancel : 1,
			buttonNames : ['Confirm', 'Cancel'],
			message : 'Are you sure you want to delete this document?',
			title : 'Delete'
		});
		dialog.addEventListener('click', function(e) {
			if (e.index === e.source.cancel) {
				Ti.API.info('The cancel button was clicked');
			} else {
				db.execute('DELETE FROM storedInfo WHERE id = "' + entryId + '"');
				if (!OS_BLACKBERRY) {
					$.inventoryItems.removeAllChildren();
				} else {
					if ($.inventoryItems.children && $.inventoryItems.children.length > 0) {
						for ( i = 0; i < $.inventoryItems.children.length; i++) {
							$.inventoryItems.remove($.inventoryItems.children[0]);
						}
					}
				}
				doRows();
			}
		});
		dialog.show();
	});
	if (entryType == "new") {
		itemDetailsTextarea.focus();
		topId++;
	}
}

function doRows() {
	var idArray = [];
	var reports = db.execute('SELECT id,type,data FROM storedInfo WHERE type = "homeDocument"');
	while (reports.isValidRow()) {

		row = JSON.parse(reports.fieldByName("data"));
		Ti.API.info(reports.fieldByName("data"));
		rowId = reports.fieldByName("id");
		idArray.push(rowId);

		addNewEntry(row, rowId, "old");

		reports.next();
	}
	topId = Math.max.apply(Math, idArray);
}
